package dev.pfaff.altargui.async;

record CompletedTask<V>(V value) implements Task<V> {
	@SuppressWarnings({"DataFlowIssue", "rawtypes"})
	static final CompletedTask COMPLETED_NULL = new CompletedTask<>(null);

	@Override
	public V join() {
		return this.value;
	}

	@Override
	public V joinUninterruptibly() {
		return this.value;
	}

	@Override
	public boolean isCompleted() {
		return true;
	}

	@Override
	public void close() {
		// nothing to do
	}
}
