package dev.pfaff.altargui.async;

import dev.pfaff.altargui.function.FallibleRunnable;
import org.jspecify.annotations.Nullable;

import java.util.concurrent.Callable;
import java.util.concurrent.Executor;

import static java.util.Objects.requireNonNull;

public final class VirtualThreadTaskExecutor implements TaskExecutor {
	public static final VirtualThreadTaskExecutor WITH_DEFAULT_EXECUTOR = new VirtualThreadTaskExecutor(null);

	private final @Nullable Executor scheduler;

	private VirtualThreadTaskExecutor(@Nullable Executor scheduler) {
		this.scheduler = scheduler;
	}

	public static VirtualThreadTaskExecutor withScheduler(Executor scheduler) {
		return new VirtualThreadTaskExecutor(requireNonNull(scheduler));
	}

	@Override
	public <V> Task<V> submit(Callable<V> callable) {
		return VirtualThreadTask.spawnVirtualTask(callable, scheduler);
	}

	@Override
	public Task<Void> submitFallible(FallibleRunnable runnable) {
		return VirtualThreadTask.spawnVirtualTask(runnable, scheduler);
	}
}
