package dev.pfaff.altargui.debug.events;

import dev.pfaff.log4truth.format.AppendTo;
import dev.pfaff.log4truth.format.Appender;

import static java.util.FormatProcessor.FMT;

public record AttachWidgetStateEvent(long parentKey, long childKey) implements WidgetStateEvent {
	@Override
	public void appendTo(Appender appender) {
		String litA = "AttachWidgetState[parentKey=";
		String litB = ", childKey=";
		String litC = "]";
		String parentKeyString = FMT."%016x\{this.parentKey}";
		String childKeyString = FMT."%016x\{this.childKey}";
		appender.reserve(litA.length() + parentKeyString.length() + litB.length() + childKeyString.length() + litC.length());
		appender.append(litA);
		appender.append(parentKeyString);
		appender.append(litB);
		appender.append(childKeyString);
		appender.append(litC);
	}

	@Override
	public String toString() {
		return AppendTo.toString(this);
	}
}
