package dev.pfaff.altargui.render;

import dev.pfaff.altargui.internal.render.CanvasImpl;
import dev.pfaff.altargui.internal.annotation.Specialize;

import java.lang.foreign.MemoryLayout;

public abstract non-sealed class RenderObject extends Uploadable implements AutoCloseable {
	public static final RenderObject[] EMPTY_ARRAY = new RenderObject[0];

	public abstract int instanceCount();

	public abstract MemoryLayout instanceLayout();

	@Specialize
	@Override
	public int size() {
		return (int) instanceLayout().byteSize() * instanceCount();
	}

	public abstract int program();

	@Override
	public abstract void close();

	@Specialize
	public void uSpecUploadCanvas(CanvasImpl canvas) {
		canvas.iSpecUpload(this, this.size());
	}

	@Specialize
	public void uSpecUploadLayered(LayeredRenderBuffer buffer) {
		buffer.iSpecUpload(this, this.program());
	}
}
