package dev.pfaff.altargui.texture;

import dev.pfaff.altargui.function.InfallibleAutoClosable;

public abstract class AbstractTextureArray implements AutoCloseable {
	public abstract InfallibleAutoClosable bound();

	/**
	 * The texture array will be bound and unbound by this method.
	 */
	public abstract void bindAndAllocate(int width, int height, int layerCount, TextureOptions options);

	/**
	 * The texture array will be bound and unbound by this method.
	 */
	public abstract void bindAndUpload(ImageSrc image, TextureHandle handle, int xOffset, int yOffset, int width, int height);

	@Override
	public abstract void close();

	public abstract void dump();
}
