package dev.pfaff.altargui.util;

import dev.pfaff.altargui.async.TaskExecutor;

import java.lang.invoke.MethodHandle;
import java.lang.invoke.MethodHandles;
import java.lang.invoke.MutableCallSite;

import static java.lang.invoke.MethodType.methodType;

public final class GLThread {
	private static final MutableCallSite EXECUTOR = new MutableCallSite(methodType(TaskExecutor.class));
	private static final MethodHandle MH_identity_TaskExecutor = MethodHandles.identity(TaskExecutor.class);

	public static void setExecutor(TaskExecutor executor) {
		EXECUTOR.setTarget(MH_identity_TaskExecutor.bindTo(executor));
	}

	/**
	 * If the current thread is the GL thread, the {@code task} <strong>may</strong> be executed immediately.
	 */
	public static TaskExecutor executor() {
		try {
			return (TaskExecutor) EXECUTOR.getTarget().invokeExact();
		} catch (Throwable e) {
			throw new RuntimeException(e);
		}
	}
}
